SystemOrganization addCategory: #ApuestasJuegos!

Trait named: #NoPoceado
	uses: {}
	category: 'ApuestasJuegos'!

!NoPoceado methodsFor: 'as yet unclassified' stamp: 'Flor 9/6/2012 23:56'!
pagarA:unosGanadores numero:unasVeces

unosGanadores do: [:apuestaGanadora | apuestaGanadora jugador recibiPlata: apuestaGanadora montoApostado * unasVeces].! !

Trait named: #Poceado
	uses: {}
	category: 'ApuestasJuegos'!

!Poceado methodsFor: 'as yet unclassified' stamp: 'Flor 9/6/2012 23:14'!
apuestas
^self requirement ! !

!Poceado methodsFor: 'as yet unclassified' stamp: 'Flor 9/6/2012 23:52'!
pagarA:unosGanadores numero:unPorcentaje
| monto |
monto:= self pozo * unPorcentaje /100 / (unosGanadores size).

unosGanadores do: [:apuestaGanadora | apuestaGanadora jugador recibiPlata: monto].! !

!Poceado methodsFor: 'as yet unclassified' stamp: 'Flor 9/6/2012 23:54'!
pozo
^ self apuestas inject: 0 into: [:acum :apuesta | acum + apuesta montoApostado ].! !

Trait named: #ReceptorDinero
	uses: {}
	category: 'ApuestasJuegos'!

!ReceptorDinero methodsFor: 'as yet unclassified' stamp: 'Flor 9/6/2012 23:57'!
capital
self requirement.! !

!ReceptorDinero methodsFor: 'as yet unclassified' stamp: 'Flor 9/6/2012 23:57'!
capital:unMonto 
	self requirement.! !

!ReceptorDinero methodsFor: 'as yet unclassified' stamp: 'Flor 9/6/2012 23:57'!
recibiPlata: unDinero
self capital: self capital + unDinero . 
! !

Object subclass: #Agencia
	uses: ReceptorDinero
	instanceVariableNames: 'cuenta capital eleccion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ApuestasJuegos'!

Agencia class
	uses: ReceptorDinero classTrait
	instanceVariableNames: ''!

!Agencia methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:16'!
capital
^ capital.
! !

!Agencia methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:17'!
capital:unMonto 
	capital := unMonto .
! !

!Agencia methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:17'!
initialize 
capital := 0.
eleccion := OrderedCollection new.
! !

Object subclass: #Apuesta
	instanceVariableNames: 'jugador juego montoApostado numerosApostados agencia'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ApuestasJuegos'!

!Apuesta methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:20'!
agencia
^agencia
! !

!Apuesta methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:20'!
agencia: unaAgencia 
agencia := unaAgencia  .
! !

!Apuesta methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:20'!
initialize 
numerosApostados := OrderedCollection new.
! !

!Apuesta methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:20'!
juego
^juego

! !

!Apuesta methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:21'!
juego:unJuego
juego := unJuego.
! !

!Apuesta methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:21'!
jugador
^jugador.

! !

!Apuesta methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:21'!
jugador:unJugador
jugador := unJugador .
! !

!Apuesta methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:21'!
montoApostado
^montoApostado.

! !

!Apuesta methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:21'!
montoApostado:unMonto
montoApostado := unMonto.
! !

!Apuesta methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:21'!
numerosApostados
^numerosApostados.
! !

!Apuesta methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:21'!
numerosApostados:unaColeccion
numerosApostados := unaColeccion .! !

Object subclass: #Criterio
	instanceVariableNames: 'Resultados nroAciertos cantidadIgualdades'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ApuestasJuegos'!

!Criterio methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:08'!
cantidadIgualdades
^cantidadIgualdades .

! !

!Criterio methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:08'!
cantidadIgualdades:unaCantidad
cantidadIgualdades := unaCantidad.! !

!Criterio methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:08'!
compara: unaEleccion con: unResultado
^true.! !

Object subclass: #GeneradorNumeros
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ApuestasJuegos'!

Object subclass: #Juego
	instanceVariableNames: 'premios jugadores misApuestas porcentajeAgencia juego porcentajeAgenciaExtra pozo pagoExtra premio apuestas resultados'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ApuestasJuegos'!

!Juego methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:12'!
agregarPremio: unPremio
premios add: unPremio .

! !

!Juego methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:12'!
apuestas 
^apuestas.
! !

!Juego methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:12'!
apuestas:unasApuestas
apuestas:= unasApuestas.
! !

!Juego methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:12'!
crearPremioCon:unCriterio yNumero:unNumero
premio := Premio new.
premio criterio: unCriterio.
premio juego: self.
premio numero: unNumero.
premios add: premio.
! !

!Juego methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:13'!
ganaAlgunPremio:unaApuesta
premios do: [:unPremio | unPremio sosGanadoPor:unaApuesta].
! !

!Juego methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:13'!
initialize 
premios := OrderedCollection  new.
apuestas  := OrderedCollection new.
resultados := OrderedCollection new.
! !

!Juego methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:13'!
jugarCon: unasApuestas.
apuestas := unasApuestas .
self obtenerResultadoRandom.
self obtenerGanadores .
self pagarlesAlasAgencias .
! !

!Juego methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:16'!
nuevoconPorcentajeParaAgencia: unPorcentaje yPagoExtra:unBooleano
juego:= self new.
juego pagoExtra: unBooleano .
juego porcentajeAgencia: unPorcentaje .
^juego.! !

!Juego methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:13'!
obtenerGanadores
apuestas do: [:unaApuesta | self ganaAlgunPremio: unaApuesta ].
! !

!Juego methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:13'!
obtenerResultadoRandom 
resultados add: 1.
resultados add: 2.
resultados add: 3.
! !

!Juego methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:13'!
pagarlesATodosLosJugadores
premios do: [:unPremio | self pagarA: unPremio misGanadores numero: unPremio numero].

! !

!Juego methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:14'!
pagarlesAlasAgencias
| tamanio |
apuestas do: [:apuesta | apuesta agencia recibiPlata: porcentajeAgencia * apuesta montoApostado /100].
tamanio= premios first misGanadores size. 
pagoExtra ifTrue: [ premios first misGanadores do: [:apuestaGanadora |apuestaGanadora agencia recibiPlata: (porcentajeAgenciaExtra * (self pozo) / 100*tamanio) ]. ]
! !

!Juego methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:14'!
pagoExtra 
^pagoExtra .
! !

!Juego methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:14'!
pagoExtra:unBooleano 
pagoExtra := unBooleano .
! !

!Juego methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:14'!
porcentajeAgencia
^porcentajeAgencia.
! !

!Juego methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:14'!
porcentajeAgencia:unPorcentaje
porcentajeAgencia:= unPorcentaje .
! !

!Juego methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:15'!
porcentajeAgenciaExtra
^porcentajeAgenciaExtra.
! !

!Juego methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:15'!
porcentajeAgenciaExtra:unPorcentaje
porcentajeAgenciaExtra:=unPorcentaje .
! !

!Juego methodsFor: 'as yet unclassified' stamp: 'Flor 9/6/2012 23:34'!
pozo
	self subclassResponsibility! !

!Juego methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:15'!
premios
^premios.

! !

!Juego methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:15'!
resultados
^resultados.! !

Juego subclass: #Loto
	uses: Poceado
	instanceVariableNames: 'resultadoPartidos ganadores sorteo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ApuestasJuegos'!

Loto class
	uses: Poceado classTrait
	instanceVariableNames: ''!

!Loto methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:34'!
apuestas
^ sorteo apuestas.! !

!Loto methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:35'!
apuestas: unaApuesta
      sorteo apuestas: unaApuesta.
! !

!Loto methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:54'!
generarPremioPara: unPorcentaje con: unaCantMinDeAciertos
"TODO"
"agencia 12%"
"otro 5% de los q vendieron los primeros premios"
	premio := Premio new.
	premio juego: self.
	premio criterio: Criterio new.
	premio porcentaje: unPorcentaje
	premio criterio cantidadIgualdades: unaCantMinDeAciertos.
	ganadores := self misApuestas select:[ :apuesta  | premio criterio compara: apuesta con: resultadoPartidos].
	ganadores do: [ :apuesta | 
	premio ganadores add: apuesta.
	premio dinero: premio porcentaje * self pozo.
	self premios add: premio.].! !

!Loto methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:53'!
generarPremios
	self generarPremioPara: 0.4 con: 6.
	self generarPremioPara: 0.17 con: 5.
	self generarPremioPara: 0.05 con: 4.! !

!Loto methodsFor: 'as yet unclassified' stamp: 'Flor 9/6/2012 23:17'!
initialize
self resultadoPartidos: Bag new.! !

!Loto methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:35'!
resultadoPartidos
	^ resultadoPartidos.
! !

Object subclass: #Jugador
	uses: ReceptorDinero
	instanceVariableNames: 'gencia apuesta misApuestas capital'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ApuestasJuegos'!

Jugador class
	uses: ReceptorDinero classTrait
	instanceVariableNames: ''!

!Jugador methodsFor: 'as yet unclassified' stamp: 'Flor 9/6/2012 23:58'!
apuestas
^misApuestas .
! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'Flor 9/6/2012 23:59'!
capital
^capital .! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'Flor 9/6/2012 23:59'!
capital:unMonto 
	capital := unMonto .
! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'Flor 9/6/2012 23:59'!
initialize 
misApuestas := OrderedCollection new.
! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:00'!
jugar:unosNumeros en:unSorteo apostando:unMonto en:unaAgencia.
apuesta:= Apuesta new.
apuesta juego: unSorteo .
apuesta jugador: self.
apuesta agencia: unaAgencia .
apuesta numerosApostados:unosNumeros.
apuesta montoApostado: unMonto .
misApuestas add: apuesta.
unSorteo recibiApuesta: apuesta.
! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'Flor 9/6/2012 23:48'!
recibiPlata! !

Object subclass: #Premio
	instanceVariableNames: 'porcentaje criterio juego misGanadores numero'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ApuestasJuegos'!

!Premio methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:01'!
criterio
^criterio.
! !

!Premio methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:01'!
criterio:unCriterio
criterio:= unCriterio .


! !

!Premio methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:02'!
initialize 
misGanadores :=OrderedCollection new.
! !

!Premio methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:02'!
juego
^juego.
! !

!Premio methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:02'!
juego:unJuego
juego:=unJuego .
! !

!Premio methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:03'!
misGanadores 
^misGanadores .! !

!Premio methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:03'!
numero
^numero.
! !

!Premio methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:03'!
numero:unNumero
numero:=unNumero .
! !

!Premio methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:04'!
pagar:unMonto a:unJugador

unJugador recibiPlata: unMonto.
! !

!Premio methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:04'!
sosGanadoPor:unaApuesta
^ (criterio compara:unaApuesta numerosApostados con: juego resultados) ifTrue:[misGanadores add: unaApuesta ].! !

Object subclass: #Sorteo
	instanceVariableNames: 'jugadores juego apuestas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ApuestasJuegos'!

!Sorteo methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:06'!
apuestas
^apuestas.

! !

!Sorteo methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:06'!
initialize 
apuestas := OrderedCollection new.
! !

!Sorteo methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:06'!
juego
^juego.

! !

!Sorteo methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:06'!
juego:unJuego
juego := unJuego .
! !

!Sorteo methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:06'!
jugar
juego jugarCon: apuestas 
! !

!Sorteo methodsFor: 'as yet unclassified' stamp: 'Flor 9/7/2012 00:06'!
recibiApuesta:unaApuesta.
apuestas add: unaApuesta .! !
